//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private PADayTradingSR[] cachePADayTradingSR = null;
        private PAShallowestTrendLinesFromYesterday[] cachePAShallowestTrendLinesFromYesterday = null;
        private PAShowBidAsk[] cachePAShowBidAsk = null;
        private PASimpleAlwaysInEMA[] cachePASimpleAlwaysInEMA = null;
        private PASuppResOpenGaps[] cachePASuppResOpenGaps = null;

        private static PADayTradingSR checkPADayTradingSR = new PADayTradingSR();
        private static PAShallowestTrendLinesFromYesterday checkPAShallowestTrendLinesFromYesterday = new PAShallowestTrendLinesFromYesterday();
        private static PAShowBidAsk checkPAShowBidAsk = new PAShowBidAsk();
        private static PASimpleAlwaysInEMA checkPASimpleAlwaysInEMA = new PASimpleAlwaysInEMA();
        private static PASuppResOpenGaps checkPASuppResOpenGaps = new PASuppResOpenGaps();

        /// <summary>
        /// Show Support and Resistance for Day Trading, Copyright PriceActionIndicators.com
        /// </summary>
        /// <returns></returns>
        public PADayTradingSR PADayTradingSR(Color hLCColor_Public, Color hLODColor_Public, int line_Thickness, Color oODColor_Public, Color oOWColor_Public, int shift_Dist, bool showHLCY, bool showHLOD, bool showOOD, bool showOOW, int text_Font_Size, bool text_Show, string website)
        {
            return PADayTradingSR(Input, hLCColor_Public, hLODColor_Public, line_Thickness, oODColor_Public, oOWColor_Public, shift_Dist, showHLCY, showHLOD, showOOD, showOOW, text_Font_Size, text_Show, website);
        }

        /// <summary>
        /// Show Support and Resistance for Day Trading, Copyright PriceActionIndicators.com
        /// </summary>
        /// <returns></returns>
        public PADayTradingSR PADayTradingSR(Data.IDataSeries input, Color hLCColor_Public, Color hLODColor_Public, int line_Thickness, Color oODColor_Public, Color oOWColor_Public, int shift_Dist, bool showHLCY, bool showHLOD, bool showOOD, bool showOOW, int text_Font_Size, bool text_Show, string website)
        {
            if (cachePADayTradingSR != null)
                for (int idx = 0; idx < cachePADayTradingSR.Length; idx++)
                    if (cachePADayTradingSR[idx].HLCColor_Public == hLCColor_Public && cachePADayTradingSR[idx].HLODColor_Public == hLODColor_Public && cachePADayTradingSR[idx].Line_Thickness == line_Thickness && cachePADayTradingSR[idx].OODColor_Public == oODColor_Public && cachePADayTradingSR[idx].OOWColor_Public == oOWColor_Public && cachePADayTradingSR[idx].Shift_Dist == shift_Dist && cachePADayTradingSR[idx].ShowHLCY == showHLCY && cachePADayTradingSR[idx].ShowHLOD == showHLOD && cachePADayTradingSR[idx].ShowOOD == showOOD && cachePADayTradingSR[idx].ShowOOW == showOOW && cachePADayTradingSR[idx].Text_Font_Size == text_Font_Size && cachePADayTradingSR[idx].Text_Show == text_Show && cachePADayTradingSR[idx].Website == website && cachePADayTradingSR[idx].EqualsInput(input))
                        return cachePADayTradingSR[idx];

            lock (checkPADayTradingSR)
            {
                checkPADayTradingSR.HLCColor_Public = hLCColor_Public;
                hLCColor_Public = checkPADayTradingSR.HLCColor_Public;
                checkPADayTradingSR.HLODColor_Public = hLODColor_Public;
                hLODColor_Public = checkPADayTradingSR.HLODColor_Public;
                checkPADayTradingSR.Line_Thickness = line_Thickness;
                line_Thickness = checkPADayTradingSR.Line_Thickness;
                checkPADayTradingSR.OODColor_Public = oODColor_Public;
                oODColor_Public = checkPADayTradingSR.OODColor_Public;
                checkPADayTradingSR.OOWColor_Public = oOWColor_Public;
                oOWColor_Public = checkPADayTradingSR.OOWColor_Public;
                checkPADayTradingSR.Shift_Dist = shift_Dist;
                shift_Dist = checkPADayTradingSR.Shift_Dist;
                checkPADayTradingSR.ShowHLCY = showHLCY;
                showHLCY = checkPADayTradingSR.ShowHLCY;
                checkPADayTradingSR.ShowHLOD = showHLOD;
                showHLOD = checkPADayTradingSR.ShowHLOD;
                checkPADayTradingSR.ShowOOD = showOOD;
                showOOD = checkPADayTradingSR.ShowOOD;
                checkPADayTradingSR.ShowOOW = showOOW;
                showOOW = checkPADayTradingSR.ShowOOW;
                checkPADayTradingSR.Text_Font_Size = text_Font_Size;
                text_Font_Size = checkPADayTradingSR.Text_Font_Size;
                checkPADayTradingSR.Text_Show = text_Show;
                text_Show = checkPADayTradingSR.Text_Show;
                checkPADayTradingSR.Website = website;
                website = checkPADayTradingSR.Website;

                if (cachePADayTradingSR != null)
                    for (int idx = 0; idx < cachePADayTradingSR.Length; idx++)
                        if (cachePADayTradingSR[idx].HLCColor_Public == hLCColor_Public && cachePADayTradingSR[idx].HLODColor_Public == hLODColor_Public && cachePADayTradingSR[idx].Line_Thickness == line_Thickness && cachePADayTradingSR[idx].OODColor_Public == oODColor_Public && cachePADayTradingSR[idx].OOWColor_Public == oOWColor_Public && cachePADayTradingSR[idx].Shift_Dist == shift_Dist && cachePADayTradingSR[idx].ShowHLCY == showHLCY && cachePADayTradingSR[idx].ShowHLOD == showHLOD && cachePADayTradingSR[idx].ShowOOD == showOOD && cachePADayTradingSR[idx].ShowOOW == showOOW && cachePADayTradingSR[idx].Text_Font_Size == text_Font_Size && cachePADayTradingSR[idx].Text_Show == text_Show && cachePADayTradingSR[idx].Website == website && cachePADayTradingSR[idx].EqualsInput(input))
                            return cachePADayTradingSR[idx];

                PADayTradingSR indicator = new PADayTradingSR();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.HLCColor_Public = hLCColor_Public;
                indicator.HLODColor_Public = hLODColor_Public;
                indicator.Line_Thickness = line_Thickness;
                indicator.OODColor_Public = oODColor_Public;
                indicator.OOWColor_Public = oOWColor_Public;
                indicator.Shift_Dist = shift_Dist;
                indicator.ShowHLCY = showHLCY;
                indicator.ShowHLOD = showHLOD;
                indicator.ShowOOD = showOOD;
                indicator.ShowOOW = showOOW;
                indicator.Text_Font_Size = text_Font_Size;
                indicator.Text_Show = text_Show;
                indicator.Website = website;
                Indicators.Add(indicator);
                indicator.SetUp();

                PADayTradingSR[] tmp = new PADayTradingSR[cachePADayTradingSR == null ? 1 : cachePADayTradingSR.Length + 1];
                if (cachePADayTradingSR != null)
                    cachePADayTradingSR.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cachePADayTradingSR = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// Draw the Shallowest Trend Lines from Yesterday as Support & Resistance for Day Trading, Copyright PriceActionIndicators.com
        /// </summary>
        /// <returns></returns>
        public PAShallowestTrendLinesFromYesterday PAShallowestTrendLinesFromYesterday(Color bearColor_Public, Color bullColor_Public, DashStyle dash0Style, int line_Thickness, string website)
        {
            return PAShallowestTrendLinesFromYesterday(Input, bearColor_Public, bullColor_Public, dash0Style, line_Thickness, website);
        }

        /// <summary>
        /// Draw the Shallowest Trend Lines from Yesterday as Support & Resistance for Day Trading, Copyright PriceActionIndicators.com
        /// </summary>
        /// <returns></returns>
        public PAShallowestTrendLinesFromYesterday PAShallowestTrendLinesFromYesterday(Data.IDataSeries input, Color bearColor_Public, Color bullColor_Public, DashStyle dash0Style, int line_Thickness, string website)
        {
            if (cachePAShallowestTrendLinesFromYesterday != null)
                for (int idx = 0; idx < cachePAShallowestTrendLinesFromYesterday.Length; idx++)
                    if (cachePAShallowestTrendLinesFromYesterday[idx].BearColor_Public == bearColor_Public && cachePAShallowestTrendLinesFromYesterday[idx].BullColor_Public == bullColor_Public && cachePAShallowestTrendLinesFromYesterday[idx].Dash0Style == dash0Style && cachePAShallowestTrendLinesFromYesterday[idx].Line_Thickness == line_Thickness && cachePAShallowestTrendLinesFromYesterday[idx].Website == website && cachePAShallowestTrendLinesFromYesterday[idx].EqualsInput(input))
                        return cachePAShallowestTrendLinesFromYesterday[idx];

            lock (checkPAShallowestTrendLinesFromYesterday)
            {
                checkPAShallowestTrendLinesFromYesterday.BearColor_Public = bearColor_Public;
                bearColor_Public = checkPAShallowestTrendLinesFromYesterday.BearColor_Public;
                checkPAShallowestTrendLinesFromYesterday.BullColor_Public = bullColor_Public;
                bullColor_Public = checkPAShallowestTrendLinesFromYesterday.BullColor_Public;
                checkPAShallowestTrendLinesFromYesterday.Dash0Style = dash0Style;
                dash0Style = checkPAShallowestTrendLinesFromYesterday.Dash0Style;
                checkPAShallowestTrendLinesFromYesterday.Line_Thickness = line_Thickness;
                line_Thickness = checkPAShallowestTrendLinesFromYesterday.Line_Thickness;
                checkPAShallowestTrendLinesFromYesterday.Website = website;
                website = checkPAShallowestTrendLinesFromYesterday.Website;

                if (cachePAShallowestTrendLinesFromYesterday != null)
                    for (int idx = 0; idx < cachePAShallowestTrendLinesFromYesterday.Length; idx++)
                        if (cachePAShallowestTrendLinesFromYesterday[idx].BearColor_Public == bearColor_Public && cachePAShallowestTrendLinesFromYesterday[idx].BullColor_Public == bullColor_Public && cachePAShallowestTrendLinesFromYesterday[idx].Dash0Style == dash0Style && cachePAShallowestTrendLinesFromYesterday[idx].Line_Thickness == line_Thickness && cachePAShallowestTrendLinesFromYesterday[idx].Website == website && cachePAShallowestTrendLinesFromYesterday[idx].EqualsInput(input))
                            return cachePAShallowestTrendLinesFromYesterday[idx];

                PAShallowestTrendLinesFromYesterday indicator = new PAShallowestTrendLinesFromYesterday();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.BearColor_Public = bearColor_Public;
                indicator.BullColor_Public = bullColor_Public;
                indicator.Dash0Style = dash0Style;
                indicator.Line_Thickness = line_Thickness;
                indicator.Website = website;
                Indicators.Add(indicator);
                indicator.SetUp();

                PAShallowestTrendLinesFromYesterday[] tmp = new PAShallowestTrendLinesFromYesterday[cachePAShallowestTrendLinesFromYesterday == null ? 1 : cachePAShallowestTrendLinesFromYesterday.Length + 1];
                if (cachePAShallowestTrendLinesFromYesterday != null)
                    cachePAShallowestTrendLinesFromYesterday.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cachePAShallowestTrendLinesFromYesterday = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// Show bid/ask on the chart as text and lines, Copyright PriceActionIndicators.com
        /// </summary>
        /// <returns></returns>
        public PAShowBidAsk PAShowBidAsk(Color askColor, Color bidColor, int fontSize, int textOffset, string website)
        {
            return PAShowBidAsk(Input, askColor, bidColor, fontSize, textOffset, website);
        }

        /// <summary>
        /// Show bid/ask on the chart as text and lines, Copyright PriceActionIndicators.com
        /// </summary>
        /// <returns></returns>
        public PAShowBidAsk PAShowBidAsk(Data.IDataSeries input, Color askColor, Color bidColor, int fontSize, int textOffset, string website)
        {
            if (cachePAShowBidAsk != null)
                for (int idx = 0; idx < cachePAShowBidAsk.Length; idx++)
                    if (cachePAShowBidAsk[idx].AskColor == askColor && cachePAShowBidAsk[idx].BidColor == bidColor && cachePAShowBidAsk[idx].FontSize == fontSize && cachePAShowBidAsk[idx].TextOffset == textOffset && cachePAShowBidAsk[idx].Website == website && cachePAShowBidAsk[idx].EqualsInput(input))
                        return cachePAShowBidAsk[idx];

            lock (checkPAShowBidAsk)
            {
                checkPAShowBidAsk.AskColor = askColor;
                askColor = checkPAShowBidAsk.AskColor;
                checkPAShowBidAsk.BidColor = bidColor;
                bidColor = checkPAShowBidAsk.BidColor;
                checkPAShowBidAsk.FontSize = fontSize;
                fontSize = checkPAShowBidAsk.FontSize;
                checkPAShowBidAsk.TextOffset = textOffset;
                textOffset = checkPAShowBidAsk.TextOffset;
                checkPAShowBidAsk.Website = website;
                website = checkPAShowBidAsk.Website;

                if (cachePAShowBidAsk != null)
                    for (int idx = 0; idx < cachePAShowBidAsk.Length; idx++)
                        if (cachePAShowBidAsk[idx].AskColor == askColor && cachePAShowBidAsk[idx].BidColor == bidColor && cachePAShowBidAsk[idx].FontSize == fontSize && cachePAShowBidAsk[idx].TextOffset == textOffset && cachePAShowBidAsk[idx].Website == website && cachePAShowBidAsk[idx].EqualsInput(input))
                            return cachePAShowBidAsk[idx];

                PAShowBidAsk indicator = new PAShowBidAsk();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.AskColor = askColor;
                indicator.BidColor = bidColor;
                indicator.FontSize = fontSize;
                indicator.TextOffset = textOffset;
                indicator.Website = website;
                Indicators.Add(indicator);
                indicator.SetUp();

                PAShowBidAsk[] tmp = new PAShowBidAsk[cachePAShowBidAsk == null ? 1 : cachePAShowBidAsk.Length + 1];
                if (cachePAShowBidAsk != null)
                    cachePAShowBidAsk.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cachePAShowBidAsk = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// Show Always In direction with recent Cs above/below EMA, Copyright PriceActionIndicators.com
        /// </summary>
        /// <returns></returns>
        public PASimpleAlwaysInEMA PASimpleAlwaysInEMA(int eMA_Period, int lookBack, int percent, string website)
        {
            return PASimpleAlwaysInEMA(Input, eMA_Period, lookBack, percent, website);
        }

        /// <summary>
        /// Show Always In direction with recent Cs above/below EMA, Copyright PriceActionIndicators.com
        /// </summary>
        /// <returns></returns>
        public PASimpleAlwaysInEMA PASimpleAlwaysInEMA(Data.IDataSeries input, int eMA_Period, int lookBack, int percent, string website)
        {
            if (cachePASimpleAlwaysInEMA != null)
                for (int idx = 0; idx < cachePASimpleAlwaysInEMA.Length; idx++)
                    if (cachePASimpleAlwaysInEMA[idx].EMA_Period == eMA_Period && cachePASimpleAlwaysInEMA[idx].LookBack == lookBack && cachePASimpleAlwaysInEMA[idx].Percent == percent && cachePASimpleAlwaysInEMA[idx].Website == website && cachePASimpleAlwaysInEMA[idx].EqualsInput(input))
                        return cachePASimpleAlwaysInEMA[idx];

            lock (checkPASimpleAlwaysInEMA)
            {
                checkPASimpleAlwaysInEMA.EMA_Period = eMA_Period;
                eMA_Period = checkPASimpleAlwaysInEMA.EMA_Period;
                checkPASimpleAlwaysInEMA.LookBack = lookBack;
                lookBack = checkPASimpleAlwaysInEMA.LookBack;
                checkPASimpleAlwaysInEMA.Percent = percent;
                percent = checkPASimpleAlwaysInEMA.Percent;
                checkPASimpleAlwaysInEMA.Website = website;
                website = checkPASimpleAlwaysInEMA.Website;

                if (cachePASimpleAlwaysInEMA != null)
                    for (int idx = 0; idx < cachePASimpleAlwaysInEMA.Length; idx++)
                        if (cachePASimpleAlwaysInEMA[idx].EMA_Period == eMA_Period && cachePASimpleAlwaysInEMA[idx].LookBack == lookBack && cachePASimpleAlwaysInEMA[idx].Percent == percent && cachePASimpleAlwaysInEMA[idx].Website == website && cachePASimpleAlwaysInEMA[idx].EqualsInput(input))
                            return cachePASimpleAlwaysInEMA[idx];

                PASimpleAlwaysInEMA indicator = new PASimpleAlwaysInEMA();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.EMA_Period = eMA_Period;
                indicator.LookBack = lookBack;
                indicator.Percent = percent;
                indicator.Website = website;
                Indicators.Add(indicator);
                indicator.SetUp();

                PASimpleAlwaysInEMA[] tmp = new PASimpleAlwaysInEMA[cachePASimpleAlwaysInEMA == null ? 1 : cachePASimpleAlwaysInEMA.Length + 1];
                if (cachePASimpleAlwaysInEMA != null)
                    cachePASimpleAlwaysInEMA.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cachePASimpleAlwaysInEMA = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// A couple of times a month Open Gaps from prior days (further back than yesterday) also play an obvious role as support or resistance on the intra-day chart, Copyright PriceActionIndicators.com
        /// </summary>
        /// <returns></returns>
        public PASuppResOpenGaps PASuppResOpenGaps(Color bearGapColor, Color bullGapColor, DashStyle dash0Style, int lineThicknessClosed, int lineThicknessOpen, bool showClosedGaps, bool showLast200, string website)
        {
            return PASuppResOpenGaps(Input, bearGapColor, bullGapColor, dash0Style, lineThicknessClosed, lineThicknessOpen, showClosedGaps, showLast200, website);
        }

        /// <summary>
        /// A couple of times a month Open Gaps from prior days (further back than yesterday) also play an obvious role as support or resistance on the intra-day chart, Copyright PriceActionIndicators.com
        /// </summary>
        /// <returns></returns>
        public PASuppResOpenGaps PASuppResOpenGaps(Data.IDataSeries input, Color bearGapColor, Color bullGapColor, DashStyle dash0Style, int lineThicknessClosed, int lineThicknessOpen, bool showClosedGaps, bool showLast200, string website)
        {
            if (cachePASuppResOpenGaps != null)
                for (int idx = 0; idx < cachePASuppResOpenGaps.Length; idx++)
                    if (cachePASuppResOpenGaps[idx].BearGapColor == bearGapColor && cachePASuppResOpenGaps[idx].BullGapColor == bullGapColor && cachePASuppResOpenGaps[idx].Dash0Style == dash0Style && cachePASuppResOpenGaps[idx].LineThicknessClosed == lineThicknessClosed && cachePASuppResOpenGaps[idx].LineThicknessOpen == lineThicknessOpen && cachePASuppResOpenGaps[idx].ShowClosedGaps == showClosedGaps && cachePASuppResOpenGaps[idx].ShowLast200 == showLast200 && cachePASuppResOpenGaps[idx].Website == website && cachePASuppResOpenGaps[idx].EqualsInput(input))
                        return cachePASuppResOpenGaps[idx];

            lock (checkPASuppResOpenGaps)
            {
                checkPASuppResOpenGaps.BearGapColor = bearGapColor;
                bearGapColor = checkPASuppResOpenGaps.BearGapColor;
                checkPASuppResOpenGaps.BullGapColor = bullGapColor;
                bullGapColor = checkPASuppResOpenGaps.BullGapColor;
                checkPASuppResOpenGaps.Dash0Style = dash0Style;
                dash0Style = checkPASuppResOpenGaps.Dash0Style;
                checkPASuppResOpenGaps.LineThicknessClosed = lineThicknessClosed;
                lineThicknessClosed = checkPASuppResOpenGaps.LineThicknessClosed;
                checkPASuppResOpenGaps.LineThicknessOpen = lineThicknessOpen;
                lineThicknessOpen = checkPASuppResOpenGaps.LineThicknessOpen;
                checkPASuppResOpenGaps.ShowClosedGaps = showClosedGaps;
                showClosedGaps = checkPASuppResOpenGaps.ShowClosedGaps;
                checkPASuppResOpenGaps.ShowLast200 = showLast200;
                showLast200 = checkPASuppResOpenGaps.ShowLast200;
                checkPASuppResOpenGaps.Website = website;
                website = checkPASuppResOpenGaps.Website;

                if (cachePASuppResOpenGaps != null)
                    for (int idx = 0; idx < cachePASuppResOpenGaps.Length; idx++)
                        if (cachePASuppResOpenGaps[idx].BearGapColor == bearGapColor && cachePASuppResOpenGaps[idx].BullGapColor == bullGapColor && cachePASuppResOpenGaps[idx].Dash0Style == dash0Style && cachePASuppResOpenGaps[idx].LineThicknessClosed == lineThicknessClosed && cachePASuppResOpenGaps[idx].LineThicknessOpen == lineThicknessOpen && cachePASuppResOpenGaps[idx].ShowClosedGaps == showClosedGaps && cachePASuppResOpenGaps[idx].ShowLast200 == showLast200 && cachePASuppResOpenGaps[idx].Website == website && cachePASuppResOpenGaps[idx].EqualsInput(input))
                            return cachePASuppResOpenGaps[idx];

                PASuppResOpenGaps indicator = new PASuppResOpenGaps();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.BearGapColor = bearGapColor;
                indicator.BullGapColor = bullGapColor;
                indicator.Dash0Style = dash0Style;
                indicator.LineThicknessClosed = lineThicknessClosed;
                indicator.LineThicknessOpen = lineThicknessOpen;
                indicator.ShowClosedGaps = showClosedGaps;
                indicator.ShowLast200 = showLast200;
                indicator.Website = website;
                Indicators.Add(indicator);
                indicator.SetUp();

                PASuppResOpenGaps[] tmp = new PASuppResOpenGaps[cachePASuppResOpenGaps == null ? 1 : cachePASuppResOpenGaps.Length + 1];
                if (cachePASuppResOpenGaps != null)
                    cachePASuppResOpenGaps.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cachePASuppResOpenGaps = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Show Support and Resistance for Day Trading, Copyright PriceActionIndicators.com
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.PADayTradingSR PADayTradingSR(Color hLCColor_Public, Color hLODColor_Public, int line_Thickness, Color oODColor_Public, Color oOWColor_Public, int shift_Dist, bool showHLCY, bool showHLOD, bool showOOD, bool showOOW, int text_Font_Size, bool text_Show, string website)
        {
            return _indicator.PADayTradingSR(Input, hLCColor_Public, hLODColor_Public, line_Thickness, oODColor_Public, oOWColor_Public, shift_Dist, showHLCY, showHLOD, showOOD, showOOW, text_Font_Size, text_Show, website);
        }

        /// <summary>
        /// Show Support and Resistance for Day Trading, Copyright PriceActionIndicators.com
        /// </summary>
        /// <returns></returns>
        public Indicator.PADayTradingSR PADayTradingSR(Data.IDataSeries input, Color hLCColor_Public, Color hLODColor_Public, int line_Thickness, Color oODColor_Public, Color oOWColor_Public, int shift_Dist, bool showHLCY, bool showHLOD, bool showOOD, bool showOOW, int text_Font_Size, bool text_Show, string website)
        {
            return _indicator.PADayTradingSR(input, hLCColor_Public, hLODColor_Public, line_Thickness, oODColor_Public, oOWColor_Public, shift_Dist, showHLCY, showHLOD, showOOD, showOOW, text_Font_Size, text_Show, website);
        }

        /// <summary>
        /// Draw the Shallowest Trend Lines from Yesterday as Support & Resistance for Day Trading, Copyright PriceActionIndicators.com
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.PAShallowestTrendLinesFromYesterday PAShallowestTrendLinesFromYesterday(Color bearColor_Public, Color bullColor_Public, DashStyle dash0Style, int line_Thickness, string website)
        {
            return _indicator.PAShallowestTrendLinesFromYesterday(Input, bearColor_Public, bullColor_Public, dash0Style, line_Thickness, website);
        }

        /// <summary>
        /// Draw the Shallowest Trend Lines from Yesterday as Support & Resistance for Day Trading, Copyright PriceActionIndicators.com
        /// </summary>
        /// <returns></returns>
        public Indicator.PAShallowestTrendLinesFromYesterday PAShallowestTrendLinesFromYesterday(Data.IDataSeries input, Color bearColor_Public, Color bullColor_Public, DashStyle dash0Style, int line_Thickness, string website)
        {
            return _indicator.PAShallowestTrendLinesFromYesterday(input, bearColor_Public, bullColor_Public, dash0Style, line_Thickness, website);
        }

        /// <summary>
        /// Show bid/ask on the chart as text and lines, Copyright PriceActionIndicators.com
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.PAShowBidAsk PAShowBidAsk(Color askColor, Color bidColor, int fontSize, int textOffset, string website)
        {
            return _indicator.PAShowBidAsk(Input, askColor, bidColor, fontSize, textOffset, website);
        }

        /// <summary>
        /// Show bid/ask on the chart as text and lines, Copyright PriceActionIndicators.com
        /// </summary>
        /// <returns></returns>
        public Indicator.PAShowBidAsk PAShowBidAsk(Data.IDataSeries input, Color askColor, Color bidColor, int fontSize, int textOffset, string website)
        {
            return _indicator.PAShowBidAsk(input, askColor, bidColor, fontSize, textOffset, website);
        }

        /// <summary>
        /// Show Always In direction with recent Cs above/below EMA, Copyright PriceActionIndicators.com
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.PASimpleAlwaysInEMA PASimpleAlwaysInEMA(int eMA_Period, int lookBack, int percent, string website)
        {
            return _indicator.PASimpleAlwaysInEMA(Input, eMA_Period, lookBack, percent, website);
        }

        /// <summary>
        /// Show Always In direction with recent Cs above/below EMA, Copyright PriceActionIndicators.com
        /// </summary>
        /// <returns></returns>
        public Indicator.PASimpleAlwaysInEMA PASimpleAlwaysInEMA(Data.IDataSeries input, int eMA_Period, int lookBack, int percent, string website)
        {
            return _indicator.PASimpleAlwaysInEMA(input, eMA_Period, lookBack, percent, website);
        }

        /// <summary>
        /// A couple of times a month Open Gaps from prior days (further back than yesterday) also play an obvious role as support or resistance on the intra-day chart, Copyright PriceActionIndicators.com
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.PASuppResOpenGaps PASuppResOpenGaps(Color bearGapColor, Color bullGapColor, DashStyle dash0Style, int lineThicknessClosed, int lineThicknessOpen, bool showClosedGaps, bool showLast200, string website)
        {
            return _indicator.PASuppResOpenGaps(Input, bearGapColor, bullGapColor, dash0Style, lineThicknessClosed, lineThicknessOpen, showClosedGaps, showLast200, website);
        }

        /// <summary>
        /// A couple of times a month Open Gaps from prior days (further back than yesterday) also play an obvious role as support or resistance on the intra-day chart, Copyright PriceActionIndicators.com
        /// </summary>
        /// <returns></returns>
        public Indicator.PASuppResOpenGaps PASuppResOpenGaps(Data.IDataSeries input, Color bearGapColor, Color bullGapColor, DashStyle dash0Style, int lineThicknessClosed, int lineThicknessOpen, bool showClosedGaps, bool showLast200, string website)
        {
            return _indicator.PASuppResOpenGaps(input, bearGapColor, bullGapColor, dash0Style, lineThicknessClosed, lineThicknessOpen, showClosedGaps, showLast200, website);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Show Support and Resistance for Day Trading, Copyright PriceActionIndicators.com
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.PADayTradingSR PADayTradingSR(Color hLCColor_Public, Color hLODColor_Public, int line_Thickness, Color oODColor_Public, Color oOWColor_Public, int shift_Dist, bool showHLCY, bool showHLOD, bool showOOD, bool showOOW, int text_Font_Size, bool text_Show, string website)
        {
            return _indicator.PADayTradingSR(Input, hLCColor_Public, hLODColor_Public, line_Thickness, oODColor_Public, oOWColor_Public, shift_Dist, showHLCY, showHLOD, showOOD, showOOW, text_Font_Size, text_Show, website);
        }

        /// <summary>
        /// Show Support and Resistance for Day Trading, Copyright PriceActionIndicators.com
        /// </summary>
        /// <returns></returns>
        public Indicator.PADayTradingSR PADayTradingSR(Data.IDataSeries input, Color hLCColor_Public, Color hLODColor_Public, int line_Thickness, Color oODColor_Public, Color oOWColor_Public, int shift_Dist, bool showHLCY, bool showHLOD, bool showOOD, bool showOOW, int text_Font_Size, bool text_Show, string website)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.PADayTradingSR(input, hLCColor_Public, hLODColor_Public, line_Thickness, oODColor_Public, oOWColor_Public, shift_Dist, showHLCY, showHLOD, showOOD, showOOW, text_Font_Size, text_Show, website);
        }

        /// <summary>
        /// Draw the Shallowest Trend Lines from Yesterday as Support & Resistance for Day Trading, Copyright PriceActionIndicators.com
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.PAShallowestTrendLinesFromYesterday PAShallowestTrendLinesFromYesterday(Color bearColor_Public, Color bullColor_Public, DashStyle dash0Style, int line_Thickness, string website)
        {
            return _indicator.PAShallowestTrendLinesFromYesterday(Input, bearColor_Public, bullColor_Public, dash0Style, line_Thickness, website);
        }

        /// <summary>
        /// Draw the Shallowest Trend Lines from Yesterday as Support & Resistance for Day Trading, Copyright PriceActionIndicators.com
        /// </summary>
        /// <returns></returns>
        public Indicator.PAShallowestTrendLinesFromYesterday PAShallowestTrendLinesFromYesterday(Data.IDataSeries input, Color bearColor_Public, Color bullColor_Public, DashStyle dash0Style, int line_Thickness, string website)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.PAShallowestTrendLinesFromYesterday(input, bearColor_Public, bullColor_Public, dash0Style, line_Thickness, website);
        }

        /// <summary>
        /// Show bid/ask on the chart as text and lines, Copyright PriceActionIndicators.com
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.PAShowBidAsk PAShowBidAsk(Color askColor, Color bidColor, int fontSize, int textOffset, string website)
        {
            return _indicator.PAShowBidAsk(Input, askColor, bidColor, fontSize, textOffset, website);
        }

        /// <summary>
        /// Show bid/ask on the chart as text and lines, Copyright PriceActionIndicators.com
        /// </summary>
        /// <returns></returns>
        public Indicator.PAShowBidAsk PAShowBidAsk(Data.IDataSeries input, Color askColor, Color bidColor, int fontSize, int textOffset, string website)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.PAShowBidAsk(input, askColor, bidColor, fontSize, textOffset, website);
        }

        /// <summary>
        /// Show Always In direction with recent Cs above/below EMA, Copyright PriceActionIndicators.com
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.PASimpleAlwaysInEMA PASimpleAlwaysInEMA(int eMA_Period, int lookBack, int percent, string website)
        {
            return _indicator.PASimpleAlwaysInEMA(Input, eMA_Period, lookBack, percent, website);
        }

        /// <summary>
        /// Show Always In direction with recent Cs above/below EMA, Copyright PriceActionIndicators.com
        /// </summary>
        /// <returns></returns>
        public Indicator.PASimpleAlwaysInEMA PASimpleAlwaysInEMA(Data.IDataSeries input, int eMA_Period, int lookBack, int percent, string website)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.PASimpleAlwaysInEMA(input, eMA_Period, lookBack, percent, website);
        }

        /// <summary>
        /// A couple of times a month Open Gaps from prior days (further back than yesterday) also play an obvious role as support or resistance on the intra-day chart, Copyright PriceActionIndicators.com
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.PASuppResOpenGaps PASuppResOpenGaps(Color bearGapColor, Color bullGapColor, DashStyle dash0Style, int lineThicknessClosed, int lineThicknessOpen, bool showClosedGaps, bool showLast200, string website)
        {
            return _indicator.PASuppResOpenGaps(Input, bearGapColor, bullGapColor, dash0Style, lineThicknessClosed, lineThicknessOpen, showClosedGaps, showLast200, website);
        }

        /// <summary>
        /// A couple of times a month Open Gaps from prior days (further back than yesterday) also play an obvious role as support or resistance on the intra-day chart, Copyright PriceActionIndicators.com
        /// </summary>
        /// <returns></returns>
        public Indicator.PASuppResOpenGaps PASuppResOpenGaps(Data.IDataSeries input, Color bearGapColor, Color bullGapColor, DashStyle dash0Style, int lineThicknessClosed, int lineThicknessOpen, bool showClosedGaps, bool showLast200, string website)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.PASuppResOpenGaps(input, bearGapColor, bullGapColor, dash0Style, lineThicknessClosed, lineThicknessOpen, showClosedGaps, showLast200, website);
        }
    }
}
#endregion
